DECLARE FUNCTION binIndex% (number%, index%)
DECLARE FUNCTION fromHex% (A$, index%)
DECLARE SUB LoadMap ()
DECLARE SUB blank ()
DECLARE SUB drawSprite (x%, y%, SPRITE%(), TScnBuf%(), TDBSXS&, TDBSYS&)
DECLARE SUB Loadgif (A$)
DECLARE SUB drawTileNB (TX%, TY%, Tile%, HF%, VF%)
DECLARE FUNCTION save% ()
DECLARE FUNCTION IVS% (number%, doit%)
DECLARE FUNCTION tohex$ (Atile AS ANY)
DECLARE FUNCTION binary$ (Atile AS ANY)
DECLARE SUB drawTileNB (TX%, TY%, Tile%, HF%, VF%)
DECLARE SUB border ()
DECLARE SUB Load (File$)
DECLARE SUB drawTile (x%, y%, Tile%, TScnBuf%(), TDBSXS&, HF%, VF%)
DECLARE SUB SetPalette ()
DECLARE SUB Drawscreen ()
DECLARE SUB clearStringBuff ()
'Sean Tasker 2002
'seantasker@rocketmail.com
'http://icedevelopment.funky.as
'If you decide to use any source from here credit would be nice =)

TYPE TextTile
        paletteNumber AS INTEGER
        VF AS INTEGER
        HF AS INTEGER
        tileNumber AS INTEGER
END TYPE

DECLARE FUNCTION decimal (Atile AS TextTile)
DECLARE SUB putRecord (filenum%, x%, y%, xsize%, byte AS TextTile, numrecs%)
DECLARE SUB setRecord (filenum%, x%, y%, xsize%, numrecs%)

TYPE RegType
      AX AS INTEGER
      BX AS INTEGER
      CX AS INTEGER
      DX AS INTEGER
      BP AS INTEGER
      SI AS INTEGER
      DI AS INTEGER
      FLAGS AS INTEGER
      DS AS INTEGER
      ES AS INTEGER
END TYPE

DIM Regs AS RegType
Regs.AX = 0
    CALL INTERRUPT(&H33, Regs, Regs)

REM $DYNAMIC

OPTION BASE 0

SetPalette

SCREEN 13
'ON ERROR GOTO FixError
'-------------------------------------------------------------------------
'=========================================================================
'*************************************************************************
'                   DIMS
'*************************************************************************
'=========================================================================
'-------------------------------------------------------------------------
DIM SHARED TileXSize AS INTEGER
DIM SHARED TileYSize AS INTEGER
DIM SHARED Xtiles AS INTEGER
DIM SHARED Ytiles AS INTEGER
DIM SHARED ScreenY AS INTEGER
DIM SHARED ScreenX AS INTEGER
DIM SHARED TileScreenY AS INTEGER
DIM SHARED TileScreenX AS INTEGER
DIM SHARED Screenytiles AS INTEGER
DIM SHARED Screenxtiles AS INTEGER
DIM SHARED TileScreenytiles AS INTEGER
DIM SHARED TileScreenxtiles AS INTEGER
DIM SHARED Xstep AS INTEGER
DIM SHARED Ystep AS INTEGER
DIM SHARED TXstep AS INTEGER
DIM SHARED TYstep AS INTEGER
DIM SHARED keycode AS INTEGER
DIM SHARED NumberofTiles AS INTEGER
DIM SHARED rxposition AS INTEGER
DIM SHARED TILESTEP AS INTEGER
DIM SHARED SpriteXSize AS INTEGER
DIM SHARED SpriteYSize AS INTEGER
DIM SHARED DBSXS AS LONG
DIM SHARED DBSYS AS LONG
DIM SHARED TileDBSXS AS LONG
DIM SHARED TileDBSYS AS LONG
DIM WindowFlag AS INTEGER
DIM MaxWindowFlag AS INTEGER
DIM tempsA AS INTEGER
DIM tempsB AS INTEGER
DIM SelectedTile AS INTEGER
DIM SelectedTileR AS INTEGER
DIM HFFlag AS INTEGER
DIM VFFlag AS INTEGER
DIM HFFlagR AS INTEGER
DIM VFFlagR AS INTEGER
DIM SHARED XNtiles%                    'On GIF
DIM SHARED YNtiles%
DIM SHARED ASTRING AS STRING
DIM SHARED tempTextTile AS TextTile
DIM SHARED fileMODE AS INTEGER
DIM SHARED PalNum AS INTEGER
DIM SHARED PalNumR AS INTEGER

PalNum = 0
PalNumR = 0
fileMODE = 0
HFFlag = 0
VFFlag = 0
HFFlagR = 0
VFFlagR = 0
WindowFlag = 0
SelectedTile = 0
MaxWindowFlag = 2
Xstep% = 0                      'offset map is displayed
Ystep% = 0
TXstep% = 0                      'offset map is displayed
TYstep% = 0

'Setup Globals
ScreenY% = 20                   'Offsets for Map screen
ScreenX% = 10
'Screenxtiles% = 38              'Number of Tiles on X for Map screen
'Screenytiles% = 20              'Number of Tiles on Y for Map screen

DO
        INPUT "Screen X Tiles:", Screenxtiles%
LOOP UNTIL Screenxtiles% < 39 AND Screenxtiles% > 5
DO
        INPUT "Screen Y Tiles:", Screenytiles%
LOOP UNTIL Screenytiles% < 19 AND Screenytiles% > 5

TileScreenytiles% = 1           'Number of Tiles on Y for Tile screen
TileScreenY% = ScreenY% + Screenytiles% * 8 + 4         'Offsets for Tile screen
TileScreenX% = ScreenX%
'----------------------------
INPUT "FILE:", File$
IF File$ > "" THEN
        IF File$ = "1" THEN
                Load "tedata.dat"
        ELSE
                Load File$               'Load header of file
        END IF
ELSE
        TileXSize% = 8
        TileYSize% = 8
        'INPUT "Number of Tiles:", NumberofTiles%
        INPUT "Map X Size:", Xtiles%
        INPUT "Map Y Size:", Ytiles%
END IF

IF File$ = "" THEN
INPUT "TILESET:", Tileset$
        IF Tileset$ > "" THEN Loadgif Tileset$
ELSE
        Loadgif ASTRING$
END IF

IF NumberofTiles% >= 10 THEN
        TileScreenxtiles% = Screenxtiles%          'Number of Tiles on X for Tile screen
ELSE
        TileScreenxtiles% = 10
END IF

'Initialize Arrays
DIM SHARED TILES(TileXSize%, TileYSize%, NumberofTiles%) AS INTEGER
'Get Sprite dimentions
READ SpriteXSize%
READ SpriteYSize%

'Initialize sprite array
REDIM SHARED MainCharSprite(SpriteXSize% + 1, SpriteYSize% + 1) AS INTEGER
MainCharSprite(0, 0) = SpriteXSize%
MainCharSprite(1, 0) = SpriteYSize%

DBSXS = Xtiles%
IF (DBSXS * Ytiles% * 8) > FRE(-1) - 64 THEN
        fileMODE = 1
        FileArray$ = "filarray.dat"
        LOCATE 24, 1: PRINT "Map too large for memory";
        LOCATE 25, 1: PRINT "Enabling File Mode";
ELSE
        DIM SHARED map(Xtiles%, Ytiles%) AS TextTile
END IF

'fill sprite array
FOR y% = 1 TO MainCharSprite(1, 0)
        FOR x% = 1 TO MainCharSprite(0, 0)
                READ MainCharSprite(x%, y%)
        NEXT x%
NEXT y%

IF File$ > "" THEN
'Load from file Map data
FOR y% = 0 TO Ytiles% - 1
        FOR x% = 0 TO Xtiles% - 1
                INPUT #1, map(x%, y%).tileNumber
        NEXT x%
NEXT y%
ELSE

IF fileMODE = 1 THEN
        OPEN FileArray$ FOR BINARY AS #2
END IF

FOR y% = 0 TO Ytiles% - 1
        FOR x% = 0 TO Xtiles% - 1
                IF fileMODE = 1 THEN
                        tempTextTile.tileNumber = 0
                        tempTextTile.HF = 0
                        tempTextTile.VF = 0
                        tempTextTile.paletteNumber = 0
                        putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                ELSE
                        map(x%, y%).tileNumber = 0
                END IF
        NEXT x%
        DBSXS = Xtiles%
        DBSYS = x%
        DBSYS = ((DBSYS * y%) / (DBSXS * Ytiles%)) * 100
        IF fileMODE = 1 THEN LOCATE 25, 20: PRINT DBSYS; "%";
NEXT y%
END IF
'Load from file Tile data
'IF TILESET$ > "" THEN
FOR TY% = 0 TO YNtiles% - 1
        FOR TX% = 0 TO XNtiles% - 1
                FOR y% = 0 TO TileYSize% - 1
                        FOR x% = 0 TO TileXSize% - 1
                                IF TX% < NumberofTiles% THEN TILES(x%, y%, TX% + (TY% * XNtiles%)) = POINT(x% + (TX% * 8), y% + (TY% * 8))
                        NEXT x%
                NEXT y%
        NEXT TX%
NEXT TY%
CLOSE #1                'finished with file
CLS
'-------------------------------------------------------------------------
'=========================================================================
'*************************************************************************
'                   DOUBLE BUFFER ARRAY/SETUP
'*************************************************************************
'=========================================================================
'-------------------------------------------------------------------------
'Create 2 double buffers (Map and Tiles)
DIM SHARED TileBuf(((TileScreenxtiles% * TileXSize%) * (TileScreenytiles% * TileYSize%)) / 2) AS INTEGER
DIM SHARED ScnBuf(((Screenxtiles% * 4) * (Screenytiles% * TileYSize%)))  AS INTEGER
DBSXS& = ((Screenxtiles% * TileXSize%))
DBSYS& = Screenytiles% * TileYSize%
ScnBuf(0) = DBSXS& * 8
ScnBuf(1) = DBSYS&
                
TileDBSXS& = ((TileScreenxtiles% * TileXSize%))
TileDBSYS& = TileScreenytiles% * TileYSize%
TileBuf%(0) = TileDBSXS& * 8
TileBuf%(1) = TileDBSYS&
 
'-----------------------------------------------
'Include for FPS update (1 of 2)
ON TIMER(1) GOSUB fpscount
TIMER ON
'-------------------------------------------------------------------------
'=========================================================================
'*************************************************************************
'                               MainLoop
'*************************************************************************
'=========================================================================
'-------------------------------------------------------------------------
border

DO
'Include for FPS update (2 of 2)
fps = fps + 1
'-------------draw buffers-----------
'NOTE: Doesn't draw using BASIC routines pokes striaght into the Double buffer
FOR y% = 0 TO Screenytiles% - 1
        FOR x% = 0 TO Screenxtiles% - 1
                IF x% < Xtiles% AND y% < Ytiles% THEN
                IF fileMODE = 1 THEN
                        setRecord 2, x% + Xstep%, y% + Ystep%, Xtiles%, 4
                        GET 2, , tempTextTile.paletteNumber
                        GET 2, , tempTextTile.VF
                        GET 2, , tempTextTile.HF
                        GET 2, , tempTextTile.tileNumber
                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF
                ELSE
                        drawTile x%, y%, map(x% + Xstep%, y% + Ystep%).tileNumber, ScnBuf%(), DBSXS&, map(x% + Xstep%, y% + Ystep%).HF, map(x% + Xstep%, y% + Ystep%).VF
                END IF
                END IF
        NEXT x%
NEXT y%

FOR Z% = 0 TO TileScreenxtiles% - 1
        drawTile Z%, 0, Z% + TILESTEP, TileBuf%(), TileDBSXS&, 0, 0
NEXT Z%
  
'Get Mouse stats
    Regs.AX = 3
    CALL INTERRUPT(&H33, Regs, Regs)
    oldxpos = xposition
    oldypos = yposition
    leftmousebutton = Regs.BX AND 1             'These values are
    rightmousebutton = (Regs.BX AND 2) \ 2      'placed in Regs by BIOS
    middlemousebutton = (Regs.BX AND 4) \ 4     'when you perform the
    yposition = Regs.DX                         'call.
    xposition = Regs.CX
    rxposition = (xposition / 2) - .1
    tempsA = ((rxposition / TileXSize%) - .4) + Xstep%
    tempsB = ((yposition / TileYSize%) - .4) + Ystep%
    keycode% = INP(&H60)

'If TAB change window. includes jump once for per press + release
IF keycode% = 15 THEN
        IF nomiddlemousebutton = 1 THEN
        nomiddlemousebutton = 0
        WindowFlag = WindowFlag + 1
        IF WindowFlag = MaxWindowFlag THEN WindowFlag = 0
        END IF
ELSE
        nomiddlemousebutton = 1
END IF

'Window watchers: "Windows" = buffers
IF WindowFlag = 1 THEN
        Regs.AX = 7
        Regs.CX = 0
        Regs.DX = (TileScreenxtiles% * TileXSize% * 2) - 1
                CALL INTERRUPT(&H33, Regs, Regs)

        Regs.AX = 8
        Regs.CX = 0
        Regs.DX = TileScreenytiles% * TileYSize% - 1
                CALL INTERRUPT(&H33, Regs, Regs)
       
        drawSprite rxposition / 1, yposition / 1, MainCharSprite(), TileBuf%(), TileDBSXS&, TileDBSYS&
ELSE
        Regs.AX = 7
        Regs.CX = 0
        Regs.DX = (Screenxtiles% * TileXSize% * 2) - 1
                CALL INTERRUPT(&H33, Regs, Regs)

        Regs.AX = 8
        Regs.CX = 0
        Regs.DX = Screenytiles% * TileYSize% - 1
                CALL INTERRUPT(&H33, Regs, Regs)

        drawSprite rxposition / 1, yposition / 1, MainCharSprite(), ScnBuf%(), DBSXS&, DBSYS&
END IF
       
'Draw buffers to the screen
PUT (ScreenX%, ScreenY%), ScnBuf, PSET
PUT (TileScreenX%, TileScreenY%), TileBuf, PSET

'Show cursor pos on tiles
drawTileNB 2, 2, SelectedTile, HFFlag, VFFlag
drawTileNB 12, 2, SelectedTileR, HFFlagR, VFFlagR

keycode% = INP(&H60)
ASTRING$ = INKEY$
'Input testing...
SELECT CASE keycode%
        CASE 75
                keyOff = 0
                IF WindowFlag = 1 THEN IF TILESTEP > 0 THEN TILESTEP = TILESTEP - 1
                IF WindowFlag = 0 THEN IF Xstep% > 0 THEN Xstep% = Xstep% - 1
        CASE 77
                keyOff = 0
                IF WindowFlag = 1 THEN IF TILESTEP + TileScreenxtiles% < NumberofTiles THEN TILESTEP = TILESTEP + 1
                IF WindowFlag = 0 THEN IF Xstep% + Screenxtiles% < Xtiles% THEN Xstep% = Xstep% + 1
        CASE 72
                keyOff = 0
                IF Ystep% > 0 THEN Ystep% = Ystep% - 1
        CASE 80
                keyOff = 0
                IF Ystep% + Screenytiles% < Ytiles% THEN Ystep% = Ystep% + 1
        CASE 16
                TIMER OFF
                blank
                clearStringBuff
                LOCATE 25, 1: INPUT ; "Quit? Y/N:", FileArray$
                IF UCASE$(FileArray$) = "Y" THEN
                CLOSE #1
                END
                END IF
                CLS
                border
                TIMER ON
        CASE 24
                TIMER OFF
                blank
                LOCATE 25, 1: INPUT ; "Left Palette:", PalNum
                CLS
                border
                TIMER ON
        CASE 25
                TIMER OFF
                blank
                LOCATE 25, 1: INPUT ; "Right Palette:", PalNumR
                CLS
                border
                TIMER ON
        CASE 71
                IF HFFlag = 0 THEN HFFlag = 1 ELSE HFFlag = 0
        CASE 73
                IF HFFlagR = 0 THEN HFFlagR = 1 ELSE HFFlagR = 0
        CASE 79
                IF VFFlag = 0 THEN VFFlag = 1 ELSE VFFlag = 0
        CASE 81
                IF VFFlagR = 0 THEN VFFlagR = 1 ELSE VFFlagR = 0
        CASE 31
                clearStringBuff
                saving = save
                CLS
                border
        CASE 38
                clearStringBuff
                LoadMap
        CASE 19
                TIMER OFF
                clearStringBuff
                blank
                LOCATE 25, 1: INPUT ; "Replace selected Left W/ Right? Y/N:", FileArray$
                IF UCASE$(FileArray$) = "Y" THEN
                FOR y% = 0 TO Ytiles% - 1
                        FOR x% = 0 TO Xtiles% - 1
                                IF map(x%, y%).tileNumber = SelectedTile THEN
                                IF fileMODE = 1 THEN
                                        tempTextTile.tileNumber = SelectedTileR
                                        tempTextTile.HF = HFFlagR
                                        tempTextTile.VF = VFFlagR
                                        tempTextTile.paletteNumber = PalNumR
                                        putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                ELSE
                                        map(x%, y%).tileNumber = SelectedTileR
                                        map(x%, y%).HF = HFFlagR
                                        map(x%, y%).VF = VFFlagR
                                        map(x%, y%).paletteNumber = PalNumR
                                END IF
                                END IF
                        NEXT x%
                NEXT y%
                END IF
                CLS
                border
                TIMER ON
        CASE 18
                TIMER OFF
                clearStringBuff
                blank
                LOCATE 25, 1: PRINT "Direction 1-" + CHR$(24) + " 2-" + CHR$(25) + " 3- 4-";
                LOCATE 25, 26: INPUT ; Direction%
                        SELECT CASE Direction%
                                CASE 1
                                        FOR y% = 0 TO Ytiles% - 1
                                                FOR x% = 0 TO Xtiles% - 1
                                                        IF fileMODE = 1 THEN
                                                                IF y% = Ytiles% - 1 THEN
                                                                tempTextTile.tileNumber = 0
                                                                tempTextTile.HF = 0
                                                                tempTextTile.VF = 0
                                                                tempTextTile.paletteNumber = 0
                                                                putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                                                ELSE
                                                                setRecord 2, x%, y% + 1, Xtiles%, 4
                                                                GET 2, , tempTextTile.paletteNumber
                                                                GET 2, , tempTextTile.VF
                                                                GET 2, , tempTextTile.HF
                                                                GET 2, , tempTextTile.tileNumber
                                                                putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                                                END IF
                                                        ELSE
                                                                IF y% = Ytiles% - 1 THEN
                                                                map(x%, y%).tileNumber = 0
                                                                map(x%, y%).HF = 0
                                                                map(x%, y%).VF = 0
                                                                map(x%, y%).paletteNumber = 0
                                                                ELSE
                                                                map(x%, y%).tileNumber = map(x%, y% + 1).tileNumber
                                                                map(x%, y%).HF = map(x%, y% + 1).HF
                                                                map(x%, y%).VF = map(x%, y% + 1).VF
                                                                map(x%, y%).paletteNumber = map(x%, y% + 1).paletteNumber
                                                                END IF

                                                        END IF
                                                NEXT x%
                                        NEXT y%
                                CASE 2
                                        FOR y% = Ytiles% - 1 TO 0 STEP -1
                                                FOR x% = 0 TO Xtiles% - 1
                                                        IF fileMODE = 1 THEN
                                                                IF y% = 0 THEN
                                                                tempTextTile.tileNumber = 0
                                                                tempTextTile.HF = 0
                                                                tempTextTile.VF = 0
                                                                tempTextTile.paletteNumber = 0
                                                                putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                                                ELSE
                                                                setRecord 2, x%, y% - 1, Xtiles%, 4
                                                                GET 2, , tempTextTile.paletteNumber
                                                                GET 2, , tempTextTile.VF
                                                                GET 2, , tempTextTile.HF
                                                                GET 2, , tempTextTile.tileNumber
                                                                putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                                                END IF
                                                        ELSE
                                                                IF y% = 0 THEN
                                                                map(x%, y%).tileNumber = 0
                                                                map(x%, y%).HF = 0
                                                                map(x%, y%).VF = 0
                                                                map(x%, y%).paletteNumber = 0
                                                                ELSE
                                                                map(x%, y%).tileNumber = map(x%, y% - 1).tileNumber
                                                                map(x%, y%).HF = map(x%, y% - 1).HF
                                                                map(x%, y%).VF = map(x%, y% - 1).VF
                                                                map(x%, y%).paletteNumber = map(x%, y% - 1).paletteNumber
                                                                END IF
                                                        END IF
                                                NEXT x%
                                        NEXT y%
                                CASE 3
                                        FOR y% = 0 TO Ytiles% - 1
                                                FOR x% = 0 TO Xtiles% - 1
                                                        IF fileMODE = 1 THEN
                                                                IF x% = Xtiles% - 1 THEN
                                                                tempTextTile.tileNumber = 0
                                                                tempTextTile.HF = 0
                                                                tempTextTile.VF = 0
                                                                tempTextTile.paletteNumber = 0
                                                                putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                                                ELSE
                                                                setRecord 2, x% + 1, y%, Xtiles%, 4
                                                                GET 2, , tempTextTile.paletteNumber
                                                                GET 2, , tempTextTile.VF
                                                                GET 2, , tempTextTile.HF
                                                                GET 2, , tempTextTile.tileNumber
                                                                putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                                                END IF
                                                        ELSE
                                                                IF x% = Xtiles% - 1 THEN
                                                                map(x%, y%).tileNumber = 0
                                                                map(x%, y%).HF = 0
                                                                map(x%, y%).VF = 0
                                                                map(x%, y%).paletteNumber = 0
                                                                ELSE
                                                                map(x%, y%).tileNumber = map(x% + 1, y%).tileNumber
                                                                map(x%, y%).HF = map(x% + 1, y%).HF
                                                                map(x%, y%).VF = map(x% + 1, y%).VF
                                                                map(x%, y%).paletteNumber = map(x% + 1, y%).paletteNumber
                                                                END IF
                                                        END IF
                                                NEXT x%
                                        NEXT y%
                                CASE 4
                                        FOR y% = 0 TO Ytiles% - 1
                                                FOR x% = Xtiles% - 1 TO 0 STEP -1
                                                        IF fileMODE = 1 THEN
                                                                IF x% = 0 THEN
                                                                tempTextTile.tileNumber = 0
                                                                tempTextTile.HF = 0
                                                                tempTextTile.VF = 0
                                                                tempTextTile.paletteNumber = 0
                                                                putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                                                ELSE
                                                                setRecord 2, x% - 1, y%, Xtiles%, 4
                                                                GET 2, , tempTextTile.paletteNumber
                                                                GET 2, , tempTextTile.VF
                                                                GET 2, , tempTextTile.HF
                                                                GET 2, , tempTextTile.tileNumber
                                                                putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                                                END IF
                                                        ELSE
                                                                IF x% = 0 THEN
                                                                map(x%, y%).tileNumber = 0
                                                                map(x%, y%).HF = 0
                                                                map(x%, y%).VF = 0
                                                                map(x%, y%).paletteNumber = 0
                                                                ELSE
                                                                map(x%, y%).tileNumber = map(x% - 1, y%).tileNumber
                                                                map(x%, y%).HF = map(x% - 1, y%).HF
                                                                map(x%, y%).VF = map(x% - 1, y%).VF
                                                                map(x%, y%).paletteNumber = map(x% - 1, y%).paletteNumber
                                                                END IF
                                                        END IF
                                                NEXT x%
                                        NEXT y%
                                CASE ELSE
                        END SELECT
                CLS
                border
                TIMER ON
        CASE 22
                TIMER OFF
                clearStringBuff
                blank
                LOCATE 25, 1: INPUT ; "Clear map with left tile? Y/N:", FileArray$
                IF UCASE$(FileArray$) = "Y" THEN
                FOR y% = 0 TO Ytiles% - 1
                        FOR x% = 0 TO Xtiles% - 1
                                IF fileMODE = 1 THEN
                                        tempTextTile.tileNumber = SelectedTile
                                        tempTextTile.HF = HFFlag
                                        tempTextTile.VF = VFFlag
                                        tempTextTile.paletteNumber = PalNum
                                        putRecord 2, x%, y%, Xtiles%, tempTextTile, 4
                                ELSE
                                        map(x%, y%).tileNumber = SelectedTile
                                        map(x%, y%).HF = HFFlag
                                        map(x%, y%).VF = VFFlag
                                        map(x%, y%).paletteNumber = PalNum
                                END IF
                        NEXT x%
                NEXT y%
                END IF
                CLS
                border
                TIMER ON
        CASE ELSE
                keyOff = 1
END SELECT

IF leftmousebutton THEN
        IF WindowFlag = 0 THEN
                IF (tempsA < Xtiles%) AND (tempsB < Ytiles%) THEN
                        IF fileMODE = 1 THEN
                                tempTextTile.tileNumber = SelectedTile
                                tempTextTile.HF = HFFlag
                                tempTextTile.VF = VFFlag
                                tempTextTile.paletteNumber = PalNum
                                putRecord 2, tempsA, tempsB, Xtiles%, tempTextTile, 4
                        ELSE
                                map(tempsA, tempsB).tileNumber = SelectedTile
                                map(tempsA, tempsB).HF = HFFlag
                                map(tempsA, tempsB).VF = VFFlag
                                map(tempsA, tempsB).paletteNumber = PalNum
                        END IF
                END IF
        ELSEIF WindowFlag = 1 THEN
                tempsA = ((rxposition / TileXSize%) - .4)
                IF (tempsA < NumberofTiles) THEN
                        SelectedTile = tempsA + TILESTEP
                END IF
        END IF
END IF

IF rightmousebutton THEN
        IF WindowFlag = 0 THEN
                IF (tempsA < Xtiles%) AND (tempsB < Ytiles%) THEN
                        IF fileMODE = 1 THEN
                                tempTextTile.tileNumber = SelectedTileR
                                tempTextTile.HF = HFFlagR
                                tempTextTile.VF = VFFlagR
                                tempTextTile.paletteNumber = PalNumR
                                putRecord 2, tempsA, tempsB, Xtiles%, tempTextTile, 4
                        ELSE
                                map(tempsA, tempsB).tileNumber = SelectedTileR
                                map(tempsA, tempsB).HF = HFFlagR
                                map(tempsA, tempsB).VF = VFFlagR
                                map(tempsA, tempsB).paletteNumber = PalNumR
                        END IF
                END IF
        ELSEIF WindowFlag = 1 THEN
                tempsA = ((rxposition / TileXSize%) - .4)
                IF (tempsA < NumberofTiles) THEN
                        SelectedTileR = tempsA + TILESTEP
                END IF
        END IF
END IF

LOOP

'*************************************************************************
'                               FPSSHTUFF
'*************************************************************************

fpscount:
LOCATE 25, 1: PRINT "FPS:"; fps;
fps = 0
RETURN

'*************************************************************************
'                          ERROR HANDLING
'*************************************************************************
FixError:
DO
        blank
        LOCATE 20, 1: PRINT "Error :", ERR;
        LOCATE 21, 1: PRINT "Make selection:";
        LOCATE 22, 1: PRINT "1. Save Current";
        LOCATE 23, 1: PRINT "2. Resume (May not work)";
        LOCATE 24, 1: PRINT "3. Exit Current";
        LOCATE 25, 1: PRINT ":";
        ASTRING$ = INPUT$(1)
        SELECT CASE ASTRING$
                CASE "1":
                        clearStringBuff
                        saving = save
                CASE "2":
                        RESUME
                CASE "3":
                        END
        END SELECT
LOOP
'-------------------------------------------------------------------------
'=========================================================================
'*************************************************************************
'                               DATA
'*************************************************************************
'=========================================================================
'-------------------------------------------------------------------------
'Cursor dimentions
DATA 8, 8
'Cursor data
DATA 77,77,77,77,-1,-1,-1,-1
DATA 77,77,-1,-1,-1,-1,-1,-1
DATA 77,-1,77,-1,-1,-1,-1,-1
DATA 77,-1,-1,77,-1,-1,-1,-1
DATA -1,-1,-1,-1,-1,-1,-1,-1
DATA -1,-1,-1,-1,-1,-1,-1,-1
DATA -1,-1,-1,-1,-1,-1,-1,-1
DATA -1,-1,-1,-1,-1,-1,-1,-1

REM $STATIC
FUNCTION binary$ (Atile AS TextTile)
        DIM number AS INTEGER
        DIM RNumber AS INTEGER
        number = decimal(Atile)
        binString$ = ""
        FOR BinFollow = 0 TO 15
                RNumber = number MOD 2
                number = (number / 2) - .4
                IF RNumber = 1 THEN
                        binString$ = binString$ + "1"
                ELSE
                        binString$ = binString$ + "0"
                END IF
        NEXT BinFollow
                FOR x = 16 TO 1 STEP -1
                        Temp$ = Temp$ + MID$(binString$, x, 1)
                NEXT x
        binary$ = Temp$
END FUNCTION

FUNCTION binIndex% (number%, index%)
        SELECT CASE number%
                CASE 0
                        A$ = "0000"
                CASE 1
                        A$ = "0001"
                CASE 2
                        A$ = "0010"
                CASE 3
                        A$ = "0011"
                CASE 4
                        A$ = "0100"
                CASE 5
                        A$ = "0101"
                CASE 6
                        A$ = "0110"
                CASE 7
                        A$ = "0111"
                CASE 8
                        A$ = "1000"
                CASE 9
                        A$ = "1001"
                CASE 10
                        A$ = "1010"
                CASE 11
                        A$ = "1011"
                CASE 12
                        A$ = "1100"
                CASE 13
                        A$ = "1101"
                CASE 14
                        A$ = "1110"
                CASE 15
                        A$ = "1111"
                CASE ELSE
        END SELECT
                IF UCASE$(MID$(A$, index%, 1)) = "1" THEN binIndex% = 1 ELSE binIndex% = 0
END FUNCTION

SUB blank
LOCATE 25, 1: PRINT "                                        ";
END SUB

SUB border
LINE (ScreenX% - 1, ScreenY% - 1)-STEP((Screenxtiles% * 8) + 1, (Screenytiles% * 8) + 1), 14, BF
LINE (TileScreenX% - 1, TileScreenY% - 1)-STEP((TileScreenxtiles% * 8) + 1, (TileScreenytiles% * 8) + 1), 14, BF
END SUB

SUB clearStringBuff
        DO
        LOOP UNTIL INKEY$ = ""
END SUB

FUNCTION decimal (Atile AS TextTile)
        DIM TpaletteNumber AS INTEGER
        DIM TVF AS INTEGER
        DIM THF AS INTEGER
        DIM finalNum AS INTEGER

        TpaletteNumber = Atile.paletteNumber * 4096

        IF Atile.VF THEN
                TVF = 2048
        ELSE
                TVF = 0
        END IF
       
        IF Atile.HF THEN
                THF = 1024
        ELSE
                THF = 0
        END IF

        finalNum = TpaletteNumber + TVF + THF + Atile.tileNumber

        decimal = finalNum
END FUNCTION

SUB drawSprite (x%, y%, SPRITE%(), TScnBuf%(), TDBSXS&, TDBSYS&)
DEF SEG = VARSEG(TScnBuf%(0))
        FOR yy% = 1 TO SPRITE%(1, 0)
        FOR xxx% = 1 TO SPRITE%(0, 0)
                xx% = x% + xxx% - 1
                yyyy& = (y% + yy% - 1) * TDBSXS&
                colour% = SPRITE%(xxx%, yy%)
                IF xx% < TDBSXS& AND y% + yy% < TDBSYS& + 1 THEN IF SPRITE%(xxx%, yy%) <> -1 THEN POKE (VARPTR(TScnBuf%(2)) + xx% + yyyy&), colour%
        NEXT xxx%
        NEXT yy%
END SUB

SUB drawTile (x%, y%, Tile%, TScnBuf%(), TDBSXS&, HF%, VF%)
DEF SEG = VARSEG(TScnBuf%(0))
        FOR yy% = 0 TO TileYSize% - 1
        FOR xxx% = 0 TO TileXSize% - 1
                xx% = (x% * TileXSize%) + xxx%
                yyyy& = ((y% * TileYSize%) + yy%) * TDBSXS&
                colour% = TILES(IVS(xxx%, HF%), IVS(yy%, VF%), Tile%)
                IF xx% < TDBSXS& THEN POKE (VARPTR(TScnBuf%(2)) + yyyy& + xx%), colour%
        NEXT xxx%
        NEXT yy%
END SUB

SUB drawTileNB (TX%, TY%, Tile%, HF%, VF%)
        FOR y% = 0 TO TileYSize% - 1
        FOR x% = 0 TO TileXSize% - 1
                PSET (TX% + x%, TY% + y%), TILES(IVS(x%, HF%), IVS(y%, VF%), Tile%)
        NEXT x%
        NEXT y%
END SUB

FUNCTION fromHex% (A$, index%)
        SELECT CASE UCASE$(MID$(A$, index%, 1))
                CASE "F"
                        fromHex% = 15
                CASE "E"
                        fromHex% = 14
                CASE "D"
                        fromHex% = 13
                CASE "C"
                        fromHex% = 12
                CASE "B"
                        fromHex% = 11
                CASE "A"
                        fromHex% = 10
                CASE ELSE
                        fromHex% = VAL(UCASE$(MID$(A$, index%, 1)))
        END SELECT
END FUNCTION

FUNCTION IVS% (number%, doit%)
        IF doit% > 0 THEN
                SELECT CASE (number%)
                        CASE 0: IVS = 7
                        CASE 1: IVS = 6
                        CASE 2: IVS = 5
                        CASE 3: IVS = 4
                        CASE 4: IVS = 3
                        CASE 5: IVS = 2
                        CASE 6: IVS = 1
                        CASE 7: IVS = 0
                END SELECT
        ELSE
                IVS = number%
        END IF
END FUNCTION

SUB Load (File$)
OPEN File$ FOR INPUT AS #1
        INPUT #1, TileXSize%
        INPUT #1, TileYSize%
        INPUT #1, NumberofTiles%
        INPUT #1, Xtiles%
        INPUT #1, Ytiles%
        INPUT #1, ASTRING$
END SUB

SUB Loadgif (A$)
' Author unknown
DEFINT A-Z
DIM Prefix(4095), Suffix(4095), OutStack(4095), shiftout%(8)
DIM Ybase AS LONG, powersof2(11) AS LONG, WorkCode AS LONG

FOR A% = 0 TO 7: shiftout%(8 - A%) = 2 ^ A%: NEXT A%
FOR A% = 0 TO 11: powersof2(A%) = 2 ^ A%: NEXT A%
IF INSTR(A$, ".") = 0 THEN A$ = A$ + ".gif"

OPEN A$ FOR BINARY AS #2
A$ = "      ": GET #2, , A$
IF A$ <> "GIF87a" THEN PRINT "Not a GIF87a file.": END
GET #2, , TotalX: GET #2, , TotalY: GOSUB Getbytea
NumColors = 2 ^ ((A% AND 7) + 1): NoPalette = (A% AND 128) = 0
GOSUB Getbytea: Background = A%
GOSUB Getbytea: IF A% <> 0 THEN PRINT "Bad screen descriptor.": END
IF NoPalette = 0 THEN p$ = SPACE$(NumColors * 3): GET #2, , p$
DO
    GOSUB Getbytea
    IF A% = 44 THEN
        EXIT DO
    ELSEIF A% <> 33 THEN
        PRINT "Unknown extension type.": END
    END IF
    GOSUB Getbytea
    DO: GOSUB Getbytea: A$ = SPACE$(A%): GET #2, , A$: LOOP UNTIL A% = 0
LOOP
GET #2, , XStart: GET #2, , YStart: GET #2, , XLength: GET #2, , YLength
XEnd = XStart + XLength: YEnd = YStart + YLength: GOSUB Getbytea
IF A% AND 128 THEN PRINT "Can't handle local colormaps.": END
Interlaced = A% AND 64: PassNumber = 0: PassStep = 8
GOSUB Getbytea
ClearCode = 2 ^ A%
EOSCode = ClearCode + 1
FirstCode = ClearCode + 2: NextCode = FirstCode
StartCodeSize = A% + 1: CodeSize = StartCodeSize
StartMaxCode = 2 ^ (A% + 1) - 1: MaxCode = StartMaxCode

BitsIn = 0: BlockSize = 0: BlockPointer = 1
x% = XStart: y% = YStart: Ybase = y% * 320&

SCREEN 13: DEF SEG = &HA000
IF NoPalette = 0 THEN
    OUT &H3C7, 0: OUT &H3C8, 0
    FOR A% = 1 TO NumColors * 3: OUT &H3C9, ASC(MID$(p$, A%, 1)) \ 4: NEXT A%
END IF
LINE (0, 0)-(319, 199), Background, BF
DO
    GOSUB Getcodea
    IF Code <> EOSCode THEN
        IF Code = ClearCode THEN
            NextCode = FirstCode
            CodeSize = StartCodeSize
            MaxCode = StartMaxCode
            GOSUB Getcodea
            CurCode = Code: LastCode = Code: LastPixel = Code
            IF x% < 320 THEN POKE x% + Ybase, LastPixel
            x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLinea
        ELSE
            CurCode = Code: StackPointer = 0
            IF Code > NextCode THEN EXIT DO
            IF Code = NextCode THEN
                CurCode = LastCode
                OutStack(StackPointer) = LastPixel
                StackPointer = StackPointer + 1
            END IF

            DO WHILE CurCode >= FirstCode
                OutStack(StackPointer) = Suffix(CurCode)
                StackPointer = StackPointer + 1
                CurCode = Prefix(CurCode)
            LOOP

            LastPixel = CurCode
            IF x% < 320 THEN POKE x% + Ybase, LastPixel
            x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLinea

            FOR A% = StackPointer - 1 TO 0 STEP -1
                IF x% < 320 THEN POKE x% + Ybase, OutStack(A%)
                x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLinea
            NEXT A%

            IF NextCode < 4096 THEN
                Prefix(NextCode) = LastCode
                Suffix(NextCode) = LastPixel
                NextCode = NextCode + 1
                IF NextCode > MaxCode AND CodeSize < 12 THEN
                    CodeSize = CodeSize + 1
                    MaxCode = MaxCode * 2 + 1
                END IF
            END IF
            LastCode = Code
        END IF
    END IF
KEY(1) ON
LOOP UNTIL DoneFlag OR Code = EOSCode
GOTO witea

Getbytea: A$ = " ": GET #2, , A$: A% = ASC(A$): RETURN

NextScanLinea:
    IF Interlaced THEN
        y% = y% + PassStep
        IF y% >= YEnd THEN
            PassNumber = PassNumber + 1
            SELECT CASE PassNumber
            CASE 1: y% = 4: PassStep = 8
            CASE 2: y% = 2: PassStep = 4
            CASE 3: y% = 1: PassStep = 2
            END SELECT
        END IF
    ELSE
        y% = y% + 1
    END IF
    x% = XStart: Ybase = y% * 320&: DoneFlag = y% > 199
RETURN
Getcodea:
    IF BitsIn = 0 THEN GOSUB ReadBufferedBytea: LastChar = A%: BitsIn = 8
    WorkCode = LastChar \ shiftout%(BitsIn)
    DO WHILE CodeSize > BitsIn
        GOSUB ReadBufferedBytea: LastChar = A%
        WorkCode = WorkCode OR LastChar * powersof2(BitsIn)
        BitsIn = BitsIn + 8
    LOOP
    BitsIn = BitsIn - CodeSize
    Code = WorkCode AND MaxCode
RETURN
ReadBufferedBytea:
    IF BlockPointer > BlockSize THEN
        GOSUB Getbytea: BlockSize = A%
        A$ = SPACE$(BlockSize): GET #2, , A$
        BlockPointer = 1
    END IF
    A% = ASC(MID$(A$, BlockPointer, 1)): BlockPointer = BlockPointer + 1
RETURN
witea:
CLOSE #2

XNtiles% = TotalX \ 8
YNtiles% = TotalY \ 8
NumberofTiles% = XNtiles% * YNtiles%

END SUB

DEFSNG A-Z
SUB LoadMap
         TIMER OFF
         LOCATE 25, 1: INPUT ; "Mode:", savemode%
         blank
         LOCATE 25, 1: INPUT ; "Load:", location$
         blank
         IF UCASE$(location$) = "C" THEN EXIT SUB
        
SELECT CASE savemode%
        CASE 0
         OPEN location$ FOR INPUT AS #1
     
         'Takes next point to read from
         FOR writeLoopY% = 0 TO 7: LINE INPUT #1, location$: NEXT writeLoopY%
         writeLoopX% = 1
         DO
         A$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         LOOP UNTIL A$ = "["
         A$ = ""
         DO
         B$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         IF B$ = "*" THEN  ELSE A$ = A$ + B$
         LOOP UNTIL B$ = "*"
         Xtiles% = VAL(A$)
         A$ = ""
         DO
         B$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         IF B$ = "]" THEN  ELSE A$ = A$ + B$
         LOOP UNTIL B$ = "]"
         Ytiles% = VAL(A$)
         'PRINT Xtiles%; "*"; Ytiles%;
         Temp& = Xtiles%
         IF Temp& * Ytiles% > 32768 THEN
                IF fileMODE = 0 THEN
                        FileArray$ = "filarray.dat"
                        OPEN FileArray$ FOR BINARY AS #2
                        fileMODE = 1
                END IF
         ELSE
                REDIM map(Xtiles%, Ytiles%) AS TextTile
         END IF
         FOR writeLoopY% = 0 TO Ytiles% - 1
                FOR writeLoopX% = 0 TO Xtiles% - 1
                        INPUT #1, A$
                        IF A$ = "" THEN INPUT #1, A$
                      
                                tempTextTile.paletteNumber = fromHex%(A$, 3) * 16
                                tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                      
                        IF fileMODE = 1 THEN
                                putRecord 2, writeLoopX%, writeLoopY%, Xtiles%, tempTextTile, 4
                        ELSE
                                map(writeLoopX%, writeLoopY%).tileNumber = tempTextTile.tileNumber
                                map(writeLoopX%, writeLoopY%).HF = tempTextTile.HF
                                map(writeLoopX%, writeLoopY%).VF = tempTextTile.VF
                                map(writeLoopX%, writeLoopY%).paletteNumber = tempTextTile.paletteNumber
                        END IF
                NEXT writeLoopX%
                Temp& = Xtiles%
                Temp2& = writeLoopX%
                Temp2& = ((Temp2& * writeLoopY%) / (Temp& * Ytiles%)) * 100
                LOCATE 25, 1: PRINT "Loading "; Temp2&; "% complete";
         NEXT writeLoopY%
         CLOSE #1
         TIMER ON
CASE 1
        'LOCATE 25, 1: INPUT ; "nosectionsX:", nosectionsX%
        'blank
        'LOCATE 25, 1: INPUT ; "nosectionsY:", nosectionsY%
        'blank
         OPEN location$ FOR INPUT AS #1
        
         'Takes next point to read from
         FOR writeLoopY% = 0 TO 7: LINE INPUT #1, location$: NEXT writeLoopY%
         writeLoopX% = 1
         DO
         A$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         LOOP UNTIL A$ = "["
         A$ = ""
         DO
         B$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         IF B$ = "*" THEN  ELSE A$ = A$ + B$
         LOOP UNTIL B$ = "*"
         Xtiles% = VAL(A$)
         A$ = ""
         DO
         B$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         IF B$ = "]" THEN  ELSE A$ = A$ + B$
         LOOP UNTIL B$ = "]"
         Ytiles% = VAL(A$)
         nosectionsX% = Xtiles% / 32
         nosectionsY% = Ytiles% / 32
         Temp& = Xtiles%
         IF Temp& * Ytiles% > 32768 THEN
                IF fileMODE = 0 THEN
                        FileArray$ = "filarray.dat"
                        OPEN FileArray$ FOR BINARY AS #2
                        fileMODE = 1
                END IF
         ELSE
                REDIM map(Xtiles%, Ytiles%) AS TextTile
         END IF
        
        FOR sectionLoopY% = 0 TO nosectionsY% - 1
        FOR sectionLoopX% = 0 TO nosectionsX% - 1
         FOR writeLoopY% = (sectionLoopY% * 32) TO ((sectionLoopY%) * 32) + 31
                FOR writeLoopX% = (sectionLoopX% * 32) TO ((sectionLoopX%) * 32) + 31
                        INPUT #1, A$
                        IF A$ = "" THEN INPUT #1, A$
                      
                        tempTextTile.paletteNumber = fromHex%(A$, 3) * 16
                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                     
                        IF fileMODE = 1 THEN
                                putRecord 2, writeLoopX%, writeLoopY%, Xtiles%, tempTextTile, 4
                        ELSE
                                map(writeLoopX%, writeLoopY%).tileNumber = tempTextTile.tileNumber
                                map(writeLoopX%, writeLoopY%).HF = tempTextTile.HF
                                map(writeLoopX%, writeLoopY%).VF = tempTextTile.VF
                        END IF
                NEXT writeLoopX%
         NEXT writeLoopY%
        NEXT sectionLoopX%
                Temp& = Xtiles%
                Temp2& = sectionLoopX%
                Temp2& = ((Temp2& * sectionLoopY% * 1024) / (Temp& * Ytiles%)) * 100
                LOCATE 25, 1: PRINT "Loading "; Temp2&; "% complete";
        NEXT sectionLoopY%
         CLOSE #1
         TIMER ON
END SELECT
CLS
border
END SUB

SUB putRecord (filenum%, x%, y%, xsize%, byte AS TextTile, numrecs%)
        Temp& = y%
        Temp& = (Temp& * xsize% * numrecs% * 2)
        SEEK filenum%, (x% * numrecs% * 2 + 1) + Temp&
        PUT filenum%, SEEK(filenum%), byte.paletteNumber
        PUT filenum%, SEEK(filenum%), byte.VF
        PUT filenum%, SEEK(filenum%), byte.HF
        PUT filenum%, SEEK(filenum%), byte.tileNumber
END SUB

FUNCTION save%
TIMER OFF
         LOCATE 25, 1: INPUT ; "Mode:", savemode%
         blank
         LOCATE 25, 1: INPUT ; "Save where:", location$
         blank
         IF UCASE$(location$) = "C" THEN EXIT FUNCTION
         
SELECT CASE savemode%
        CASE 0
         OPEN location$ FOR OUTPUT AS #1
        
         PRINT #1, "/***********************************\"
         PRINT #1, "|                                   |"
         PRINT #1, "| Exported by Ice D                 |"
         PRINT #1, "| Using: NME V0.45 Mode 0           |"
         PRINT #1, "| http://icedevelopment.funky.as    |"
         PRINT #1, "|                                   |"
         PRINT #1, "\***********************************/"
       
        
         PRINT #1, ("const u16 map[ " + STR$(Xtiles%) + "*" + STR$(Ytiles%) + " ] = {")
        
         FOR writeLoopY% = 0 TO Ytiles% - 1
                FOR writeLoopX% = 0 TO Xtiles% - 1
                        IF fileMODE = 1 THEN
                                setRecord 2, writeLoopX%, writeLoopY%, Xtiles%, 4
                                GET 2, , tempTextTile.paletteNumber
                                GET 2, , tempTextTile.VF
                                GET 2, , tempTextTile.HF
                                GET 2, , tempTextTile.tileNumber
                     
                                PRINT #1, ("0x" + tohex$(tempTextTile));
                        ELSE
                                PRINT #1, ("0x" + tohex$(map(writeLoopX%, writeLoopY%)));
                        END IF
                        IF writeLoopX% = Xtiles% - 1 THEN PRINT #1, "," ELSE PRINT #1, ",";
                NEXT writeLoopX%
                Temp& = Xtiles%
                Temp2& = writeLoopX%
                Temp2& = ((Temp2& * writeLoopY%) / (Temp& * Ytiles%)) * 100
                LOCATE 25, 1: PRINT "Saving "; Temp2&; "% complete";
         NEXT writeLoopY%
        
         PRINT #1, "};"
         PRINT #1, ""
         CLOSE #1
         TIMER ON
         save = 1
CASE 1
        LOCATE 25, 1: INPUT ; "nosectionsX:", nosectionsX%
        blank
        LOCATE 25, 1: INPUT ; "nosectionsY:", nosectionsY%
        blank
         OPEN location$ FOR OUTPUT AS #1
       
         PRINT #1, "/***********************************\"
         PRINT #1, "|                                   |"
         PRINT #1, "| Exported by Ice D                 |"
         PRINT #1, "| Using: NME V0.45 Mode 1           |"
         PRINT #1, "| http://icedevelopment.funky.as    |"
         PRINT #1, "|                                   |"
         PRINT #1, "\***********************************/"

         PRINT #1, ("const u16 map[" + STR$(Ytiles%) + "*" + STR$(Ytiles%) + " ] = {")
         
        FOR sectionLoopY% = 0 TO nosectionsY% - 1
        FOR sectionLoopX% = 0 TO nosectionsX% - 1
         FOR writeLoopY% = (sectionLoopY% * 32) TO ((sectionLoopY%) * 32) + 31
                FOR writeLoopX% = (sectionLoopX% * 32) TO ((sectionLoopX%) * 32) + 31
                        IF fileMODE = 1 THEN
                                setRecord 2, writeLoopX%, writeLoopY%, Xtiles%, 4
                                GET 2, , tempTextTile.paletteNumber
                                GET 2, , tempTextTile.VF
                                GET 2, , tempTextTile.HF
                                GET 2, , tempTextTile.tileNumber
                      
                                PRINT #1, ("0x" + tohex$(tempTextTile));
                        ELSE
                                PRINT #1, ("0x" + tohex$(map(writeLoopX%, writeLoopY%)));
                        END IF
                        IF writeLoopX% >= ((sectionLoopX%) * 32) + 31 THEN PRINT #1, "," ELSE PRINT #1, ",";
                NEXT writeLoopX%

         NEXT writeLoopY%
        NEXT sectionLoopX%
                Temp& = Xtiles%
                Temp2& = sectionLoopX%
                Temp2& = ((Temp2& * sectionLoopY% * 1024) / (Temp& * Ytiles%)) * 100
                LOCATE 25, 1: PRINT "Saving "; Temp2&; "% complete";
        NEXT sectionLoopY%
        
         PRINT #1, "};"
         PRINT #1, ""
         CLOSE #1
         TIMER ON
         save = 1

END SELECT
CLS
border
END FUNCTION

SUB SetPalette

END SUB

SUB setRecord (filenum%, x%, y%, xsize%, numrecs%)
        Temp& = y%
        Temp& = (Temp& * xsize% * numrecs% * 2)
        SEEK filenum%, (x% * numrecs% * 2 + 1) + Temp&
END SUB

FUNCTION tohex$ (Atile AS TextTile)
        'DIM binString AS STRING * 16
        'DIM hexString AS STRING * 16
        binString$ = binary$(Atile)
        FOR x = 0 TO 3
                IF MID$(binString$, (x * 4) + 1, 4) = "0000" THEN hexString$ = hexString$ + "0"
                IF MID$(binString$, (x * 4) + 1, 4) = "0001" THEN hexString$ = hexString$ + "1"
                IF MID$(binString$, (x * 4) + 1, 4) = "0010" THEN hexString$ = hexString$ + "2"
                IF MID$(binString$, (x * 4) + 1, 4) = "0011" THEN hexString$ = hexString$ + "3"
                IF MID$(binString$, (x * 4) + 1, 4) = "0100" THEN hexString$ = hexString$ + "4"
                IF MID$(binString$, (x * 4) + 1, 4) = "0101" THEN hexString$ = hexString$ + "5"
                IF MID$(binString$, (x * 4) + 1, 4) = "0110" THEN hexString$ = hexString$ + "6"
                IF MID$(binString$, (x * 4) + 1, 4) = "0111" THEN hexString$ = hexString$ + "7"
                IF MID$(binString$, (x * 4) + 1, 4) = "1000" THEN hexString$ = hexString$ + "8"
                IF MID$(binString$, (x * 4) + 1, 4) = "1001" THEN hexString$ = hexString$ + "9"
                IF MID$(binString$, (x * 4) + 1, 4) = "1010" THEN hexString$ = hexString$ + "A"
                IF MID$(binString$, (x * 4) + 1, 4) = "1011" THEN hexString$ = hexString$ + "B"
                IF MID$(binString$, (x * 4) + 1, 4) = "1100" THEN hexString$ = hexString$ + "C"
                IF MID$(binString$, (x * 4) + 1, 4) = "1101" THEN hexString$ = hexString$ + "D"
                IF MID$(binString$, (x * 4) + 1, 4) = "1110" THEN hexString$ = hexString$ + "E"
                IF MID$(binString$, (x * 4) + 1, 4) = "1111" THEN hexString$ = hexString$ + "F"
        NEXT x
        tohex$ = hexString$
END FUNCTION

